use strict;

package Acme::Scrmable;
use base qw (Exporter);

$Acme::Scrmable::VERSION = '1.0';
@Acme::Scrmable::EXPORT  = qw (pirnt pinrt
			       pnirt pnrit
			       prnit);

*pirnt = \&_print;
*pinrt = \&_print;
*pnirt = \&_print;
*pnrit = \&_print;
*prnit = \&_print;

sub _print {
    my $text = shift;
    
    foreach my $word (split (/\b/,$text)) {
	#print "[debug] \$word is '$word'\n";

	unless ($word =~ /\w{4}/) {
	    print "$word";
	    next;
	}

	my @w = split (//,$word);
	my $A = shift @w;
	my $Z = pop @w;

	print $A;

	if (defined ($Z)) {

	    my $word = join("",@w);
	    my $wrod = &_scrmable(@w);
	    my $i    = 0;

	    while ($wrod eq $word) {

		$wrod = &_scrmable(@w);
		$i++;

		if ($i >= 64) {
		    last;
		}
	    }

	    print $wrod,$Z;
	}
    }
}

sub _scrmable {
    my @w = @_;

    my %tt;
    foreach (@w) { $tt{$_} = rand; }
    @w = sort { $tt{$a} <=> $tt{$b}; } @w;

    return join("",@w);
}


return 1;

__END__

=head1 NAME

Acme::Scrmable - eptorxs pluibc fitucnnos for iiplmmteenng jwz's scmablred txet aolitrhgm.

=head1 SYNOPSIS

 use Acme::Scrmable;

 # buecase tehre is no way to orriedve
 # Prel's biult-in 'pinrt' foicnutn :-(

 pirnt "this is the network of our disconnect\n";

=head1 DESCRIPTION

If you can raed tihs you snepd too mcuh tmie in fonrt of yuor cteupomr.

=head1 PUBLIC FUNCTIONS

=head2 pirnt($str)

rurents a srntig

=head2 pinrt($str)

rurents a srntig

=head2 pnirt($str)

rurents a srntig

=head2 pnrit($str)

rurents a srntig

=head2 prnit($str)

rurents a srntig

=head1 VERSION

1.0

=head1 DATE

$Date$

=head1 AUTHOR

Aroan Sutrap Cpoe

=head1 SEE ALSO 

http://joi.ito.com/archives/2003/09/14/ordering_of_letters_dont_matter.html

http://www.jwz.org/hacks/scrmable.pl

=head1 LICENSE

This is free software, you may use it and distribute it under the same terms
as Perl itself.

Coyprgiht (c) 2003 Jamie Zawinski <jwz@jwz.org>

Premssioin to use, cpoy, mdoify, drusbiitte, and slel this stafowre and its
docneimuatton for any prsopue is hrbeey ganrted wuihott fee, prveodid taht
the avobe cprgyioht noicte appaer in all coipes and that both taht
cohgrypit noitce and tihs premssioin noitce aeppar in suppriotng
dcoumetioantn.  No rpeersneatiotns are made about the siuatbliity of tihs
srofawte for any puorpse.  It is provedid "as is" wiuotht exerpss or 
ilmpied waanrrty.

=cut
